/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-19 at 20:46:50 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.games.model;

/**
 * This is a JSON template for an achievement unlock response
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Play Game Services API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class AchievementUnlockResponse extends com.google.api.client.json.GenericJson {

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#achievementUnlockResponse.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Whether this achievement was newly unlocked (that is, whether the unlock request for the
   * achievement was the first for the player).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean newlyUnlocked;

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#achievementUnlockResponse.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#achievementUnlockResponse.
   * @param kind kind or {@code null} for none
   */
  public AchievementUnlockResponse setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Whether this achievement was newly unlocked (that is, whether the unlock request for the
   * achievement was the first for the player).
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getNewlyUnlocked() {
    return newlyUnlocked;
  }

  /**
   * Whether this achievement was newly unlocked (that is, whether the unlock request for the
   * achievement was the first for the player).
   * @param newlyUnlocked newlyUnlocked or {@code null} for none
   */
  public AchievementUnlockResponse setNewlyUnlocked(java.lang.Boolean newlyUnlocked) {
    this.newlyUnlocked = newlyUnlocked;
    return this;
  }

  @Override
  public AchievementUnlockResponse set(String fieldName, Object value) {
    return (AchievementUnlockResponse) super.set(fieldName, value);
  }

  @Override
  public AchievementUnlockResponse clone() {
    return (AchievementUnlockResponse) super.clone();
  }

}
